#!/usr/bin/perl

use File::Basename;
use File::Copy;
use File::Spec;
use File::Path;

#Fetch environment
foreach (keys %ENV) {
  $$_ = "$ENV{$_}";
}

$CurDir = `pwd`; chop $CurDir;

$HOTFIX_NAME = $VERSION;

$DELIVERY_DIR = basename $INSTDIR;
$DELIVERY_DIR = File::Spec->catfile("$ABS_ROOT_UP", "$DELIVERY_DIR", "${ARCH}.patchzip-${HOTFIX_NAME}");
$DELIVERY_ALL = File::Spec->catdir("$DELIVERY_DIR", "all");

#
# Fill in the build number
# and the name of packages 
# into the upgrade script
# which is delivered to 
# the customer.
#
sub patch_upgrade_script {

  my $file = File::Spec->catfile("$CurDir","postpatch.pl");
  my $deliver_to =  File::Spec->catfile("$DELIVERY_ALL","postpatch.pl");

  if( ! -f "$file") {
    print "$file not found\n";
    return 1;
  }
  open(IN, "$file");
  open(OUT, ">$deliver_to") || die "Could not create $deliver_to, $!";

  while(<IN>) {
    if( /<BUILD_NUMBER_PLACEHOLDER>/ ) {
      $GET_BUILD_NUM =~ s/\\//g;
      $GET_BUILD_NUM =~ s/\"//g;
      print OUT "\$BUILD_NUMBER = \"$GET_BUILD_NUM\";\n";
    }
    else {
      print OUT;
    }
  }
  close IN;
  close OUT;
}

# Copy the upgrade.pl patched with correct Build Number
patch_upgrade_script;

